#--*-coding:utf-8-*--

class DesperateRun < DiceBot
  
  def initialize
    super
    @sendMode = 2
    @sortType = 1
    @d66Type = 2
  end
  def gameName
    'Desperate Run'
  end
  
  def gameType
    "DesperateRun"
  end
  
  def prefixs
    ['(RC\d+|DDC|ACT|ITEMT|DOUKIT|FLAGT|ENTRYT|ROADT).*']
  end
  
  def getHelpMessage
    info = <<INFO_MESSAGE_TEXT
・難易度算出コマンド　DDC
・判定コマンド　RCx　or　RCx+y　or　RCx-y（x＝難易度、y=修正値（省略可能））
・アクシデント表　ACT
・初期アイテム表　ITEMT
・動機表　DOUKIT
・死亡フラグ台詞表　FLAGT
・途中参加動機表　ENTRYT
・途中参加道中表　ROADT
Desperate Run TRPG　byかむらい
INFO_MESSAGE_TEXT
  end
  
  
  
  def rollDiceCommand(command)
    debug("rollDiceCommand begin string", command)
    
    result = ''
    
    result = checkRoll(command)
    return result unless(result.empty?)
    
    
    debug("各種表として処理")
    return rollTableCommand(command)
  end
  
  
  def checkRoll(string)
    debug("checkRoll begin string", string)
    
    return '' unless(/^RC(\d+)(([+]|[-])(\d+))?$/i =~ string)
    
    target = $1.to_i
    operator = $3
    value = $4.to_i
    modify = 0
    
    result = "判定　難易度：#{target}　"
    
    unless( operator.nil? )
      modify = value  if( operator == "+")
      modify = value * (-1)  if( operator == "-")
      result += "修正値：#{modify}　"
    end
    
            
        d1, = roll(1, 6)
        d2, = roll(1, 6)

        result += "＞　出目：#{d1}、#{d2}　＞　"
     
     if(d1==d2)
        result += "ゾロ目！【Ｃｒｉｔｉｃａｌ】"
     elsif(d1+d2==7)
		result += "ダイスの出目が表裏！【Ｆｕｍｂｌｅ】"
	 elsif(d1+d2+modify>=target)
	    result += "#{d1+d2+modify}、難易度以上！【Ｓｕｃｃｅｓｓ】"
	 else
	    result += "#{d1+d2+modify}、難易度未満！【Ｍｉｓｓ】"
	 end

    return result
  end

  
  ####################
  # 各種表
  
  def rollTableCommand(command)
    command = command.upcase
    result = []
    
    debug("rollDiceCommand command", command)
    
    counts = 1
    
    case command
    when "DDC"
      result = choiceddcTable(counts)
    when "ACT"
      result = choiceactTable(counts)
    when "ITEMT"
      result = choiceitemTable(counts)
    when "DOUKIT"
      result = choicedoukiTable(counts)
    when "FLAGT"
      result = choiceflagTable(counts)
    when "ENTRYT"
      result = choiceentryTable(counts)
    when "ROADT"
      result = choiceroadTable(counts)
    else
      return
    end
    
    return result
  end


###呼び出し＋α

  def choiceddcTable(counts)
      
      name = "難易度決定"
      text = "#{name}："      

      d1, = roll(1, 6)
      d2, = roll(1, 6)
      text += "　出目：#{d1}、#{d2}　＞　"
      
      if(d1>=d2)
        text += "#{d1}－#{d2}＝#{d1-d2}　＞　難易度#{5+(d1-d2)}"
      else
        text += "#{d2}－#{d1}＝#{d2-d1}　＞　難易度#{5+(d2-d1)}"
      end

     return text
  end


  def choiceactTable(counts)
      
      name = "アクシデント表"
      text = "#{name}:"   
      
         d1, = roll(1, 6)

    case d1
    when 1
      text += "出目1　＞　ＰＣ全員、隊列を１Ｄ６で決める（１２：前列、３４：中列、５６：後列）"
    when 2
      text += "出目2　＞　１ターン、モンスター側のみ行動する。"
    when 3
      text += "出目3　＞　この戦闘の行動順が、ＰＣ→モンスター、から、モンスター→ＰＣに変わる。"
    when 4
      text += "出目4　＞　ＰＣ全員、アイテム１つを選んで失う。"
    when 5
      text += "出目5　＞　ＰＣ全員１Ｄ６を振る。この戦闘中、その出目はノープランになる。"
    when 6
      text += "出目6　＞　ＰＣ全員、Ｆｌａｇが１増加する。"
    else
      return
    end

     return text
  end
  
  def choiceitemTable(counts)

      name = "初期アイテム表"
      text = "#{name}:"   
      
         d1, = roll(1, 6)
         d2, = roll(1, 6)

    case d1+d2
    when 2
      text += "出目：#{d1}＋#{d2}　＞　2　＞　ロケットランチャー　効果：（装備）マカブルＬｖ＋３　回数：攻撃１回"
    when 3
      text += "出目：#{d1}＋#{d2}　＞　3　＞　キーピック　効果：（消費）ムーブシーンで使用可。判定の出目の合計＋１　回数：２回"
    when 4
      text += "出目：#{d1}＋#{d2}　＞　4　＞　レーダー　効果：（装備）ノープラン　装備時、「危険」を１減らすことが出来る　回数：危険減少２回"
    when 5
      text += "出目：#{d1}＋#{d2}　＞　5　＞　食料　効果：（消費）ムーブシーンで使用可。Ｌｉｆｅ３回復　回数：１回"
    when 6
      text += "出目：#{d1}＋#{d2}　＞　6　＞　応急キット　効果：（装備）メディカルＬｖ＋１　回数：回復３回"
    when 7
      text += "出目：#{d1}＋#{d2}　＞　7　＞　刃物　効果：（装備）アタックＬｖ＋１　回数：攻撃６回"
    when 8
      text += "出目：#{d1}＋#{d2}　＞　8　＞　銃　効果：（装備）シュートＬｖ＋１　回数：攻撃６回"
    when 9
      text += "出目：#{d1}＋#{d2}　＞　9　＞　ドラッグ　効果：（消費）いつでも使用可。Ｂｒａｖｅ１回復　回数：１回"
    when 10
      text += "出目：#{d1}＋#{d2}　＞　10　＞　金券　効果：（消費）アフタープレイで使用可。経験点＋２　回数：１回"
    when 11
      text += "出目：#{d1}＋#{d2}　＞　11　＞　プロテクター　効果：（装備）ガードＬｖ＋１　回数：防御５回"
    when 12
      text += "出目：#{d1}＋#{d2}　＞　12　＞　トミーガン　効果：（装備）チェーンＬｖ＋５　回数：攻撃１回"
    else
      return
    end

     return text

  end
  
    def choicedoukiTable(counts)
      
      name = "動機表"
      text = "#{name}:"   
      
         d1, = roll(1, 6)

    case d1
    when 1
      text += "出目1　＞　隷属。何か弱みに付け込まれ、嫌々ながらも参加することとなる。後ろめたい事、借金、など。"
    when 2
      text += "出目2　＞　献身。この番組は誰かのために出ている。病気の家族を救うため、参加者の一人が恋人である、など。"
    when 3
      text += "出目3　＞　成行。望んでいないのに参加することとなってしまった。誰かが勝手に申し込んだ、紛れ込んでしまった、など。"
    when 4
      text += "出目4　＞　渇望。とにかく何かを欲して参加している。金、スリル、金で手に入るもの、など。"
    when 5
      text += "出目5　＞　奇人。好き好んでこの番組に出ている。殺人癖、ナルシスト、自殺願望、化け物マニア、など。"
    when 6
      text += "出目6　＞　仕事。この番組に出るのは仕事だからだ。賞金稼ぎ、芸能人、記者、番組スタッフ、など。"
    else
      return
    end

     return text
  end
  
  def choiceflagTable(counts)
      
      name = "死亡フラグ台詞表"
      text = "#{name}:"   
      
         d1, = roll(1, 6)

    case d1
    when 1
      text += "出目1　＞　希望。「これが終わったら、一緒に酒でも飲もうや」「もう何も怖くない」など。"
    when 2
      text += "出目2　＞　望郷。「くそっ、、、俺には、帰りを待つ人が、、、っ！」「ああ、故郷のマルゲリータをもう一度食べたかった、、、」など。"
    when 3
      text += "出目3　＞　狂乱。「お前を、殺せば、俺は、億万長者なんだよぉぉぉお！！」「ヒハッ、死ね死ね死ね死ねぇぇぇぇ」など。"
    when 4
      text += "出目4　＞　絶望。「もうだめだぁ、、、おしまいだぁ、、、」「く、くるなっ、くるなぁぁぁぁ！！」など。"
    when 5
      text += "出目5　＞　慢心。「なんだ、こんなやつ、俺だけで十分だ」「大丈夫だ、問題ない」など。"
    when 6
      text += "出目6　＞　犠牲。「ふふ、俺なら大丈夫だ、、、気にするな」「お前ら下がれっ！ここは俺に任せろ！」など。"
    else
      return
    end

     return text
  end
  
  def choiceentryTable(counts)
      
      name = "途中参加動機表"
      text = "#{name}:"   
      
         d1, = roll(1, 6)

    case d1
    when 1
      text += "出目1　＞　遅刻。もともと参加する予定だったのだが遅れてしまった。今からでも走れと無理矢理参加。"
    when 2
      text += "出目2　＞　現住。もともとここに住んでいた。何？番組？え？あ、お金もらえんの？イイネ！"
    when 3
      text += "出目3　＞　突発。もともと視聴者としてスタジオに居たんだけど、司会にうまく乗せられて・・・"
    when 4
      text += "出目4　＞　乱入。何か目的があって乱入した。今回のステージが簡単に見えたり、参加者に大事な人がいたのかもしれない。"
    when 5
      text += "出目5　＞　神隠。今回より前の番組に参加していたが行方不明・死んだと思われていた。が。君はまだここにいる。"
    when 6
      text += "出目6　＞　職員。あれ、逃げ遅れました？あらあら、大変ですね、しょうがないから参加者さんと一緒に走ってください。"
    else
      return
    end

     return text
  end
  
  def choiceroadTable(counts)
      
      name = "途中参加道中表"
      text = "#{name}:"   
      
         d1, = roll(1, 6)

    case d1
    when 1
      text += "出目1　＞　死線。死ぬかと思った。Ｆｌａｇ＋１"
    when 2
      text += "出目2　＞　怪我。痛い。Ｌｉｆｅ－１"
    when 3
      text += "出目3　＞　失意。どうしてこうなった。Ｂｒａｖｅ－１。減らせない場合、Ｆｌａｇ＋１"
    when 4
      text += "出目4　＞　紛失。どっかいった。Ｉｔｅｍをどれか１つ捨てる。捨てれない場合、Ｆｌａｇ＋１"
    when 5
      text += "出目5　＞　追尾。後ろ！後ろーっ！参加開始部屋の危険＋１"
    when 6
      text += "出目6　＞　迷子。あれ、ここどこだ？途中参加道中表を振る回数＋２"
    else
      return
    end

     return text
  end
  
end